#include "main.h"

int main()
{
	Time system_time;
	system_time.setMinutes(11);
	system_time.printTime();

	Time other_time(20, 29);
	other_time.printTime();

	Time copy_time = other_time;
	addHours(6, copy_time);
	addMinutes(64, copy_time);
	copy_time.printTime();
	return 0;
} 

Time::Time()
{
	time_t current_time;
	time(&current_time);

	struct tm *timeinfo = localtime(&current_time);
	setHours(timeinfo->tm_hour);
	setMinutes(timeinfo->tm_min);

	printf("Create %x\n", this);
}

Time::Time(int hours, int minutes)
{
	setHours(hours);
	setMinutes(minutes);

	printf("Create %x\n", this);
}

Time::Time(const Time &obj)
{
	setHours(obj.hours);
	setMinutes(obj.minutes);
	
	printf("Create %x\n", this);
}

Time::~Time()
{
	printf("Delete %x\n", this);
}

void Time::setHours(int value)
{
	if (value < 0 || value > 24) {
		value = 0;
	}
	hours = value;
}

void Time::setMinutes(int value)
{
	if (value < 0 || value > 60) {
		value = 0;
	}
	minutes = value;
}

void addHours(int value, Time &obj)
{
	if (value + obj.getHours() < 0) {
		value = -obj.getHours();
	} else if (value + obj.getHours() > 24) {
		value -= 24;
	}
	obj.setHours(obj.getHours() + value);
}

void addMinutes(int value, Time &obj)
{
	if (value + obj.getMinutes() < 0) {
		addHours(-1, obj);
		value += 60;
		addMinutes(value, obj);
	} else if (value + obj.getMinutes() > 60) {
		addHours(1, obj);
		value -= 60;
		addMinutes(value, obj);
	} else {
		obj.setMinutes(obj.getMinutes() + value);
	}
}

int Time::getHours()
{
	return hours;
}

int Time::getMinutes()
{
	return minutes;
}

void Time::printTime()
{
	printf("%02d:%02d\n", getHours(), getMinutes());
}